using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BeWo.Data.Entities;
using BeWo.Report;
using BeWo.Report.ReportObjects;
using BS.Shared;
using DevExpress.XtraReports.UI;

namespace LebenshilfeRemscheid
{
	public class LHRemscheidReportCreator : DefaultReportCreator
	{
		public override XtraReport CreateServiceOverviewAllCustomersReport(int month, int year, long orgaOid, long empOid, long? serviceCategoryOid, int startDay, int endDay)
		{
			List<ServicesOverviewRO> lROs = ServicesOverviewRO.Create(month, year, orgaOid, empOid, startDay, endDay);

			if (lROs.Count > 0)
			{

				var rootReport = CreateServicesOverviewReportForRo(lROs[0], serviceCategoryOid);
				rootReport.CreateDocument();

				for (int i = 1; i < lROs.Count; i++)
				{
					var lNext = CreateServicesOverviewReportForRo(lROs[i], serviceCategoryOid);
					lNext.CreateDocument();
					rootReport.Pages.AddRange(lNext.Pages);
				}

				return rootReport;
			}
			return new XtraReport();
		}

		public override XtraReport CreateServiceOverviewSingleCustomerReport(long customerOid, int month, int year, long orgaOid, long empOid, long? serviceCategoryOid, int startDay, int endDay)
		{
			var ro = ServicesOverviewRO.Create(customerOid, month, year, false, orgaOid, empOid, startDay, endDay, serviceCategoryOid);

			return CreateServicesOverviewReportForRo(ro, serviceCategoryOid);

		}

		private XtraReport CreateServicesOverviewReportForRo(ServicesOverviewRO ro, long? serviceCategoryOid)
		{
			IBeWoReport<ServicesOverviewRO> report = null;


			if (ro.CostBearer2SupportConceptList != null && ro.CostBearer2SupportConceptList.Count > 0)
			{
				var c2s = ro.CostBearer2SupportConceptList[0];

				Customer c = c2s.SupportConcept.Customer;
				foreach (var v2o in c.ValueList)
				{
					if (v2o.Entry.Type == ValueListEntryType.CustomerCareType && v2o.Entry.Value == "Flex")
					{
						report = new LebenshilfeRemscheid.StundenzettelFlex();
					}
				}

			}
			
			//bool isFlex = false;
			
			//if (ro.Services != null)
			//{
			//	foreach (var sr in ro.Services)
			//	{

			//		if (sr.ServiceCategory == "Flex")
			//		{
			//			isFlex = true;
			//		}
					
			//	}
			//}
			//if (isFlex)
			//{
			//	report = new LebenshilfeRemscheid.StundenzettelFlex();
			//}


			if (report == null)
				report = new LebenshilfeRemscheid.Stundenzettel();
			report.SetReportDataSource(ro);

			return report as XtraReport;
		}
	}
}
